package nl.kallestruik.dtweaks.tweaks.craftingtweaks

import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.Bukkit
import org.bukkit.Material
import org.bukkit.NamespacedKey
import org.bukkit.inventory.ItemStack
import org.bukkit.inventory.ShapedRecipe
import org.bukkit.plugin.java.JavaPlugin

class CraftableNametag(
    private val plugin: JavaPlugin
): ITweak {
    private var recipeKey = NamespacedKey(plugin, "nametag")

    override fun getIdentifier(): String = "CraftableNametag"
    override fun getCategories(): List<String> = listOf("crafting", "survival")

    override fun onEnable() {
        val nametagRecipe = ShapedRecipe(recipeKey, ItemStack(Material.NAME_TAG))
        nametagRecipe.shape(" IS", " PI", "P  ")
        nametagRecipe.setIngredient('I', Material.IRON_INGOT)
        nametagRecipe.setIngredient('P', Material.PAPER)
        nametagRecipe.setIngredient('S', Material.STRING)

        plugin.server.addRecipe(nametagRecipe)
    }

    override fun onDisable() {
        plugin.server.removeRecipe(recipeKey)
    }
}