package nl.kallestruik.dtweaks.tweaks.craftingtweaks

import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.Bukkit
import org.bukkit.Material
import org.bukkit.NamespacedKey
import org.bukkit.inventory.ItemStack
import org.bukkit.inventory.ShapelessRecipe
import org.bukkit.plugin.java.JavaPlugin

class IceDecompression(
    private val plugin: JavaPlugin
): ITweak {
    private var packedIceKey = NamespacedKey(plugin, "packed_ice")
    private var iceKey = NamespacedKey(plugin, "ice")

    override fun getIdentifier(): String = "IceDecompression"
    override fun getCategories(): List<String> = listOf("crafting", "survival")

    override fun onEnable() {
        // Blue Ice -> Packed Ice
        val packedIceRecipe = ShapelessRecipe(packedIceKey, ItemStack(Material.PACKED_ICE, 9))
        packedIceRecipe.addIngredient(Material.BLUE_ICE)
        plugin.server.addRecipe(packedIceRecipe)

        // Packed Ice -> Ice
        val iceRecipe = ShapelessRecipe(iceKey, ItemStack(Material.ICE, 9))
        iceRecipe.addIngredient(Material.PACKED_ICE)
        plugin.server.addRecipe(iceRecipe)
    }

    override fun onDisable() {
        plugin.server.removeRecipe(packedIceKey)
        plugin.server.removeRecipe(iceKey)
    }
}