package nl.kallestruik.dtweaks.tweaks.croptweaks

import nl.kallestruik.dlib.DUtil
import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.Location
import org.bukkit.Material
import org.bukkit.Particle
import org.bukkit.event.EventHandler
import org.bukkit.event.HandlerList
import org.bukkit.event.Listener
import org.bukkit.event.block.Action
import org.bukkit.event.player.PlayerInteractEvent
import org.bukkit.inventory.EquipmentSlot
import org.bukkit.plugin.java.JavaPlugin

class LilypadBonemealing(
    private val plugin: JavaPlugin,
    private val util: DUtil
): ITweak, Listener {
    override fun getIdentifier(): String = "LilypadBonemealing"
    override fun getCategories(): List<String> = listOf("crops", "survival")

    override fun onEnable() {
        plugin.server.pluginManager.registerEvents(this, plugin)
    }

    override fun onDisable() {
        HandlerList.unregisterAll(this)
    }

    @EventHandler
    fun onRightClickBlock(event: PlayerInteractEvent) {
        val player = event.player
        if (event.hand != EquipmentSlot.HAND) return
        if (event.action != Action.RIGHT_CLICK_BLOCK) return
        if (event.clickedBlock == null) return
        if (event.clickedBlock!!.type != Material.LILY_PAD) return

        val itemInHand = player.inventory.itemInMainHand
        if (itemInHand.type != Material.BONE_MEAL) return

        val world = event.clickedBlock!!.world
        val origin = event.clickedBlock!!.location
        for (i in 0..5) {
            val newPos: Location = origin.clone().add(util.getRandomLocationOffset(0, 3, false))
            val newBlock = world.getBlockAt(newPos)
            if (newBlock.type != Material.AIR) continue
            if (newBlock.getRelative(0, -1, 0).type != Material.WATER) continue
            newBlock.type = Material.LILY_PAD
            world.spawnParticle(Particle.VILLAGER_HAPPY, newPos, 5, 0.5, 0.5, 0.5)
        }
        itemInHand.amount = itemInHand.amount - 1
    }
}