package nl.kallestruik.dtweaks.tweaks.mobtweaks

import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.entity.Creeper
import org.bukkit.entity.EntityType
import org.bukkit.event.EventHandler
import org.bukkit.event.HandlerList
import org.bukkit.event.Listener
import org.bukkit.event.entity.EntityExplodeEvent
import org.bukkit.plugin.java.JavaPlugin

class NoCreeperGrief(
    private val plugin: JavaPlugin
): ITweak, Listener {
    override fun getIdentifier(): String = "NoCreeperGrief"
    override fun getCategories(): List<String> = listOf("mobs", "survival")

    override fun onEnable() {
        plugin.server.pluginManager.registerEvents(this, plugin)
    }

    override fun onDisable() {
        HandlerList.unregisterAll(this)
    }

    @EventHandler
    fun onCreeperExplode(event: EntityExplodeEvent) {
        if (event.entityType != EntityType.CREEPER) return
        val creeper = event.entity as Creeper
        creeper.world.createExplosion(creeper.location, event.yield, false, false)
        event.isCancelled = true
    }
}