package nl.kallestruik.dtweaks.tweaks.mobtweaks

import nl.kallestruik.dtweaks.managers.NoSpawnZoneManager
import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.event.EventHandler
import org.bukkit.event.HandlerList
import org.bukkit.event.Listener
import org.bukkit.event.entity.CreatureSpawnEvent
import org.bukkit.plugin.java.JavaPlugin

class NoSpawnZones(
    private val plugin: JavaPlugin,
    private val noSpawnZoneManager: NoSpawnZoneManager
): ITweak, Listener {
    override fun getIdentifier(): String = "NoSpawnZones"
    override fun getCategories(): List<String> = listOf("mobs")

    override fun onEnable() {
        plugin.server.pluginManager.registerEvents(this, plugin)
    }

    override fun onDisable() {
        HandlerList.unregisterAll(this)
    }

    @EventHandler
    fun onMobSpawn(event: CreatureSpawnEvent) {
        if (event.spawnReason != CreatureSpawnEvent.SpawnReason.NATURAL)
            return

        if (!noSpawnZoneManager.isChunkClaimed(event.location.chunk.x, event.location.chunk.z, event.location.world.key))
            return

        event.isCancelled = true
    }
}